<?php
/**
 *
 * @category        admintool
 * @package         wbstats
 * @author          Ruud Eisinga - dev4me.com
 * @link			https://dev4me.com/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x / WBCE 1.4
 * @requirements    PHP 7 and higher
 * @version         0.2.5.5
 * @lastmodified    December 16, 2023
 *
 */


defined('WB_PATH') OR die(header('Location: ../index.php'));

//Useragent strings to be exluded from counting
$botUserAgents = array(
	'uptime', 
	'monitor', 
	'statuscake', 
	'msnbot', 
	'bingbot', 
	'googlebot', 
	'slurp', 
	'jeeves', 
	'spider', 
	'yandex',
	'majestic',
	'crawler',
	'baidu',
	'boitho',
	'convera',
	'robot',
	'dotbot',
	'entireweb',
	'envolk',
	'exabot',
	'facebookexternalhit',
	'gigabot',
	'ilse',
	'exactseek',
	'ezooms',
	'adsbot-google',
	'urlappendbot',
	'flappybot',
	'commoncrawl',
	'domeinzoek',
	'seoengworldbot',
	'coccoc',
	'MSIE 6.0;',
	'abot',
	'dbot',
	'ebot',
	'hbot',
	'kbot',
	'lbot',
	'mbot',
	'nbot',
	'obot',
	'pbot',
	'rbot',
	'sbot',
	'tbot',
	'vbot',
	'ybot',
	'zbot',
	'bot.',
	'bot/',
	'_bot',
	'.bot',
	'/bot',
	'-bot',
	':bot',
	'(bot',
	'crawl',
	'slurp',
	'spider',
	'seek',
	'accoona',
	'acoon',
	'adressendeutschland',
	'ah-ha.com',
	'ahoy',
	'altavista',
	'ananzi',
	'anthill',
	'appie',
	'arachnophilia',
	'arale',
	'araneo',
	'aranha',
	'architext',
	'aretha',
	'arks',
	'asterias',
	'atlocal',
	'atn',
	'atomz',
	'augurfind',
	'backrub',
	'bannana_bot',
	'baypup',
	'bdfetch',
	'big brother',
	'biglotron',
	'bjaaland',
	'blackwidow',
	'blaiz',
	'blog',
	'blo.',
	'bloodhound',
	'boitho',
	'booch',
	'bradley',
	'butterfly',
	'calif',
	'cassandra',
	'ccubee',
	'cfetch',
	'charlotte',
	'churl',
	'cienciaficcion',
	'cmc',
	'collective',
	'comagent',
	'combine',
	'computingsite',
	'csci',
	'curl',
	'cusco',
	'daumoa',
	'deepindex',
	'delorie',
	'depspid',
	'deweb',
	'die blinde kuh',
	'digger',
	'ditto',
	'dmoz',
	'docomo',
	'download express',
	'dtaagent',
	'dwcp',
	'ebiness',
	'ebingbong',
	'e-collector',
	'ejupiter',
	'emacs-w3 search engine',
	'esther',
	'evliya celebi',
	'ezresult',
	'falcon',
	'felix ide',
	'ferret',
	'fetchrover',
	'fido',
	'findlinks',
	'fireball',
	'fish search',
	'fouineur',
	'funnelweb',
	'gazz',
	'gcreep',
	'genieknows',
	'getterroboplus',
	'geturl',
	'glx',
	'goforit',
	'golem',
	'grabber',
	'grapnel',
	'gralon',
	'griffon',
	'gromit',
	'grub',
	'gulliver',
	'hamahakki',
	'harvest',
	'havindex',
	'helix',
	'heritrix',
	'hku www octopus',
	'homerweb',
	'htdig',
	'html index',
	'html_analyzer',
	'htmlgobble',
	'hubater',
	'hyper-decontextualizer',
	'ia_archiver',
	'ibm_planetwide',
	'ichiro',
	'iconsurf',
	'iltrovatore',
	'image.kapsi.net',
	'imagelock',
	'incywincy',
	'indexer',
	'infobee',
	'informant',
	'ingrid',
	'inktomisearch.com',
	'inspector web',
	'intelliagent',
	'internet shinchakubin',
	'ip3000',
	'iron33',
	'israeli-search',
	'ivia',
	'jack',
	'jakarta',
	'javabee',
	'jetbot',
	'jumpstation',
	'katipo',
	'kdd-explorer',
	'kilroy',
	'knowledge',
	'kototoi',
	'kretrieve',
	'labelgrabber',
	'lachesis',
	'larbin',
	'legs',
	'libwww',
	'linkalarm',
	'link validator',
	'linkscan',
	'lockon',
	'lwp',
	'lycos',
	'magpie',
	'mantraagent',
	'mapoftheinternet',
	'marvin/',
	'mattie',
	'mediafox',
	'mediapartners',
	'mercator',
	'merzscope',
	'microsoft url control',
	'minirank',
	'miva',
	'mj12',
	'mnogosearch',
	'moget',
	'monster',
	'moose',
	'motor',
	'multitext',
	'muncher',
	'muscatferret',
	'mwd.search',
	'myweb',
	'najdi',
	'nameprotect',
	'nationaldirectory',
	'nazilla',
	'ncsa beta',
	'nec-meshexplorer',
	'nederland.zoek',
	'netcarta webmap engine',
	'netmechanic',
	'netresearchserver',
	'netscoop',
	'newscan-online',
	'nhse',
	'nokia6682/',
	'nomad',
	'noyona',
	'nutch',
	'nzexplorer',
	'objectssearch',
	'occam',
	'omni',
	'open text',
	'openfind',
	'openintelligencedata',
	'orb search',
	'osis-project',
	'pack rat',
	'pageboy',
	'pagebull',
	'page_verifier',
	'panscient',
	'parasite',
	'partnersite',
	'patric',
	'pear.',
	'pegasus',
	'peregrinator',
	'pgp key agent',
	'phantom',
	'phpdig',
	'picosearch',
	'piltdownman',
	'pimptrain',
	'pinpoint',
	'pioneer',
	'piranha',
	'plumtreewebaccessor',
	'pogodak',
	'poirot',
	'pompos',
	'poppelsdorf',
	'poppi',
	'popular iconoclast',
	'psycheclone',
	'publisher',
	'python',
	'rambler',
	'raven search',
	'roach',
	'road runner',
	'roadhouse',
	'robbie',
	'robofox',
	'robozilla',
	'rules',
	'salty',
	'sbider',
	'scooter',
	'scoutjet',
	'scrubby',
	'search.',
	'searchprocess',
	'semanticdiscovery',
	'senrigan',
	'sg-scout',
	'shark',
	'shopwiki',
	'sidewinder',
	'sift',
	'silk',
	'simmany',
	'site searcher',
	'site valet',
	'sitetech-rover',
	'skymob.com',
	'sleek',
	'smartwit',
	'sna-',
	'snappy',
	'snooper',
	'sohu',
	'speedfind',
	'sphere',
	'sphider',
	'spinner',
	'spyder',
	'steeler/',
	'suke',
	'suntek',
	'supersnooper',
	'surfnomore',
	'sven',
	'sygol',
	'szukacz',
	'tach black widow',
	'tarantula',
	'templeton',
	'/teoma',
	't-h-u-n-d-e-r-s-t-o-n-e',
	'theophrastus',
	'titan',
	'titin',
	'tkwww',
	'toutatis',
	't-rex',
	'tutorgig',
	'twiceler',
	'twisted',
	'ucsd',
	'udmsearch',
	'url check',
	'updated',
	'vagabondo',
	'valkyrie',
	'verticrawl',
	'victoria',
	'vision-search',
	'volcano',
	'voyager/',
	'voyager-hc',
	'w3c_validator',
	'w3m2',
	'w3mir',
	'walker',
	'wallpaper',
	'wanderer',
	'wauuu',
	'wavefire',
	'web core',
	'web hopper',
	'web wombat',
	'webbandit',
	'webcatcher',
	'webcopy',
	'webfoot',
	'weblayers',
	'weblinker',
	'weblog monitor',
	'webmirror',
	'webmonkey',
	'webquest',
	'webreaper',
	'websitepulse',
	'websnarf',
	'webstolperer',
	'webvac',
	'webwalk',
	'webwatch',
	'webwombat',
	'webzinger',
	'whizbang',
	'whowhere',
	'wild ferret',
	'worldlight',
	'wwwc',
	'wwwster',
	'xenu',
	'xget',
	'xift',
	'xirq',
	'yandex',
	'yanga',
	'yeti',
	'yodao',
	'zao',
	'zippp',
	'zyborg'
); 
	